Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftmx.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftmx.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftmx.F90	(revision 7910)
@@ -25,5 +25,4 @@
    USE iom            ! I/O Manager
    USE lib_mpp        ! MPP library
-   USE wrk_nemo       ! work arrays
    USE timing         ! Timing
    USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
@@ -108,12 +107,10 @@
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
       REAL(wp) ::   ztpc         ! scalar workspace
-      REAL(wp), POINTER, DIMENSION(:,:)   ::   zkz
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   zav_tide
+      REAL(wp), DIMENSION(jpi,jpj)   ::   zkz
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zav_tide
       !!----------------------------------------------------------------------
       !
       IF( nn_timing == 1 )  CALL timing_start('zdf_tmx')
       !
-      CALL wrk_alloc( jpi,jpj,       zkz )
-      CALL wrk_alloc( jpi,jpj,jpk,   zav_tide )
       !
       !                          ! ----------------------- !
@@ -179,6 +176,4 @@
       IF(ln_ctl)   CALL prt_ctl(tab3d_1=zav_tide , clinfo1=' tmx - av_tide: ', tab3d_2=avt, clinfo2=' avt: ', ovlap=1, kdim=jpk)
       !
-      CALL wrk_dealloc( jpi,jpj,       zkz )
-      CALL wrk_dealloc( jpi,jpj,jpk,   zav_tide )
       !
       IF( nn_timing == 1 )  CALL timing_stop('zdf_tmx')
@@ -212,15 +207,13 @@
       INTEGER  ::   ji, jj, jk    ! dummy loop indices
       REAL(wp) ::   zcoef, ztpc   ! temporary scalar
-      REAL(wp), DIMENSION(:,:)  , POINTER ::   zkz                        ! 2D workspace
-      REAL(wp), DIMENSION(:,:)  , POINTER ::   zsum1 , zsum2 , zsum       !  -      -
-      REAL(wp), DIMENSION(:,:,:), POINTER ::   zempba_3d_1, zempba_3d_2   ! 3D workspace
-      REAL(wp), DIMENSION(:,:,:), POINTER ::   zempba_3d  , zdn2dz        !  -      -
-      REAL(wp), DIMENSION(:,:,:), POINTER ::   zavt_itf                   !  -      -
+      REAL(wp), DIMENSION(jpi,jpj)   ::   zkz                        ! 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj)   ::   zsum1 , zsum2 , zsum       !  -      -
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zempba_3d_1, zempba_3d_2   ! 3D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zempba_3d  , zdn2dz        !  -      -
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zavt_itf                   !  -      -
       !!----------------------------------------------------------------------
       !
       IF( nn_timing == 1 )  CALL timing_start('tmx_itf')
       !
-      CALL wrk_alloc( jpi,jpj, zkz, zsum1 , zsum2 , zsum )
-      CALL wrk_alloc( jpi,jpj,jpk, zempba_3d_1, zempba_3d_2, zempba_3d, zdn2dz, zavt_itf )
 
       !                             ! compute the form function using N2 at each time step
@@ -308,6 +301,4 @@
       END DO
       !
-      CALL wrk_dealloc( jpi,jpj, zkz, zsum1 , zsum2 , zsum )
-      CALL wrk_dealloc( jpi,jpj,jpk, zempba_3d_1, zempba_3d_2, zempba_3d, zdn2dz, zavt_itf )
       !
       IF( nn_timing == 1 )  CALL timing_stop('tmx_itf')
@@ -355,9 +346,9 @@
       INTEGER  ::   ios
       REAL(wp) ::   ztpc, ze_z   ! local scalars
-      REAL(wp), DIMENSION(:,:)  , POINTER ::  zem2, zek1     ! read M2 and K1 tidal energy
-      REAL(wp), DIMENSION(:,:)  , POINTER ::  zkz            ! total M2, K1 and S2 tidal energy
-      REAL(wp), DIMENSION(:,:)  , POINTER ::  zfact          ! used for vertical structure function
-      REAL(wp), DIMENSION(:,:)  , POINTER ::  zhdep          ! Ocean depth 
-      REAL(wp), DIMENSION(:,:,:), POINTER ::  zpc, zav_tide  ! power consumption
+      REAL(wp), DIMENSION(jpi,jpj)   ::  zem2, zek1     ! read M2 and K1 tidal energy
+      REAL(wp), DIMENSION(jpi,jpj)   ::  zkz            ! total M2, K1 and S2 tidal energy
+      REAL(wp), DIMENSION(jpi,jpj)   ::  zfact          ! used for vertical structure function
+      REAL(wp), DIMENSION(jpi,jpj)   ::  zhdep          ! Ocean depth 
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  zpc, zav_tide  ! power consumption
       !!
       NAMELIST/namzdf_tmx/ rn_htmx, rn_n2min, rn_tfe, rn_me, ln_tmx_itf, rn_tfe_itf
@@ -366,6 +357,4 @@
       IF( nn_timing == 1 )  CALL timing_start('zdf_tmx_init')
       !
-      CALL wrk_alloc( jpi,jpj,       zem2, zek1, zkz, zfact, zhdep )
-      CALL wrk_alloc( jpi,jpj,jpk,   zpc, zav_tide )
       !
       REWIND( numnam_ref )             ! Namelist namzdf_tmx in reference namelist : Tidal Mixing
@@ -534,6 +523,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi,jpj, zem2, zek1, zkz, zfact, zhdep )
-      CALL wrk_dealloc( jpi,jpj,jpk, zpc, zav_tide )
       !
       IF( nn_timing == 1 )  CALL timing_stop('zdf_tmx_init')
@@ -559,5 +546,4 @@
    USE iom            ! I/O Manager
    USE lib_mpp        ! MPP library
-   USE wrk_nemo       ! work arrays
    USE timing         ! Timing
    USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
@@ -669,17 +655,15 @@
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
       REAL(wp) ::   ztpc         ! scalar workspace
-      REAL(wp), DIMENSION(:,:)  , POINTER ::  zfact     ! Used for vertical structure
-      REAL(wp), DIMENSION(:,:)  , POINTER ::  zhdep     ! Ocean depth
-      REAL(wp), DIMENSION(:,:,:), POINTER ::  zwkb      ! WKB-stretched height above bottom
-      REAL(wp), DIMENSION(:,:,:), POINTER ::  zweight   ! Weight for high mode vertical distribution
-      REAL(wp), DIMENSION(:,:,:), POINTER ::  znu_t     ! Molecular kinematic viscosity (T grid)
-      REAL(wp), DIMENSION(:,:,:), POINTER ::  znu_w     ! Molecular kinematic viscosity (W grid)
-      REAL(wp), DIMENSION(:,:,:), POINTER ::  zReb      ! Turbulence intensity parameter
+      REAL(wp), DIMENSION(jpi,jpj)   ::  zfact     ! Used for vertical structure
+      REAL(wp), DIMENSION(jpi,jpj)   ::  zhdep     ! Ocean depth
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  zwkb      ! WKB-stretched height above bottom
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  zweight   ! Weight for high mode vertical distribution
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  znu_t     ! Molecular kinematic viscosity (T grid)
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  znu_w     ! Molecular kinematic viscosity (W grid)
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  zReb      ! Turbulence intensity parameter
       !!----------------------------------------------------------------------
       !
       IF( nn_timing == 1 )   CALL timing_start('zdf_tmx')
       !
-      CALL wrk_alloc( jpi,jpj,       zfact, zhdep )
-      CALL wrk_alloc( jpi,jpj,jpk,   zwkb, zweight, znu_t, znu_w, zReb )
 
       !                          ! ----------------------------- !
@@ -900,6 +884,4 @@
       CALL iom_put( "emix_tmx", emix_tmx )
       
-      CALL wrk_dealloc( jpi,jpj,       zfact, zhdep )
-      CALL wrk_dealloc( jpi,jpj,jpk,   zwkb, zweight, znu_t, znu_w, zReb )
 
       IF(ln_ctl)   CALL prt_ctl(tab3d_1=zav_wave , clinfo1=' tmx - av_wave: ', tab3d_2=avt, clinfo2=' avt: ', ovlap=1, kdim=jpk)
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/C14/trcatm_c14.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/C14/trcatm_c14.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/C14/trcatm_c14.F90	(revision 7910)
@@ -45,5 +45,5 @@
       REAL(wp) ::   yn20 =  20.     ! 20 degrees north
       REAL(wp) ::   yn40 =  40.     ! 40 degrees north
-      REAL(wp), POINTER, DIMENSION(:)   :: zco2, zyrco2  ! temporary arrays for swap
+      REAL(wp), DIMENSION(nrecco2)   :: zco2, zyrco2  ! temporary arrays for swap
       !
       !!----------------------------------------------------------------------
@@ -78,6 +78,4 @@
       !
          IF(kc14typ==2) THEN
-            CALL wrk_alloc( nrecco2,zco2)
-            CALL wrk_alloc( nrecco2,zyrco2)
             zco2(:)=spco2(:)
             zyrco2(:)=tyrco2(:)
@@ -88,6 +86,4 @@
                tyrco2(izco2)=1950._wp-zyrco2(jn)         ! BP to AD dates
             END DO
-            CALL wrk_dealloc(nrecco2,zco2)
-            CALL wrk_dealloc(nrecco2,zyrco2)
          ENDIF
       !
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/C14/trcwri_c14.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/C14/trcwri_c14.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/C14/trcwri_c14.F90	(revision 7910)
@@ -36,6 +36,6 @@
       INTEGER              :: ji,jj,jk,jn   ! dummy loop indexes
       REAL(wp)             :: zage,zarea,ztemp   ! temporary
-      REAL(wp), POINTER, DIMENSION(:,:)   :: zres, z2d ! temporary storage 2D
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: z3d , zz3d ! temporary storage 3D
+      REAL(wp), DIMENSION(jpi,jpj)   :: zres, z2d ! temporary storage 2D
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: z3d , zz3d ! temporary storage 3D
       !!---------------------------------------------------------------------
  
@@ -50,6 +50,4 @@
       IF( iom_use("DeltaC14") .OR. iom_use("C14Age") .OR. iom_use("RAge")   ) THEN
          !
-         CALL wrk_alloc( jpi, jpj     , z2d, zres )
-         CALL wrk_alloc( jpi, jpj, jpk, z3d, zz3d )
          !
          zage = -1._wp / rlam14 / rsiyea  ! factor for radioages in year
@@ -87,6 +85,4 @@
          CALL iom_put( "RAge" , zage * z2d(:,:) )                     ! Reservoir age [yr]
          !
-         CALL wrk_dealloc( jpi, jpj     , z2d, zres )
-         CALL wrk_dealloc( jpi, jpj, jpk, z3d, zz3d )
          !
       ENDIF
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90	(revision 7910)
@@ -43,5 +43,5 @@
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       INTEGER ::   jn   ! dummy loop index
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: ztrmyt
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: ztrmyt
       !!----------------------------------------------------------------------
       !
@@ -52,5 +52,4 @@
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
 
-      IF( l_trdtrc )  CALL wrk_alloc( jpi, jpj, jpk, ztrmyt )
 
       CALL trc_bc ( kt )       ! tracers: surface and lateral Boundary Conditions
@@ -64,5 +63,4 @@
             CALL trd_trc( ztrmyt, jn, jptra_sms, kt )   ! save trends
           END DO
-          CALL wrk_dealloc( jpi, jpj, jpk, ztrmyt )
       END IF
       !
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zbio.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zbio.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zbio.F90	(revision 7910)
@@ -96,6 +96,6 @@
       REAL(wp) ::   znh4a, zdeta, zdoma, zzoobod, zboddet, zdomaju
       REAL(wp) ::   ze3t
-      REAL(wp), POINTER,   DIMENSION(:,:,:) :: zw2d
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: zw3d
+      REAL(wp),   DIMENSION(jpi,jpj,17) :: zw2d
+      REAL(wp), DIMENSION(jpi,jpj,jpk,3) :: zw3d
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
@@ -104,6 +104,4 @@
       !
       IF( lk_iomput ) THEN
-         CALL wrk_alloc( jpi, jpj,     17, zw2d )
-         CALL wrk_alloc( jpi, jpj, jpk, 3, zw3d )
       ENDIF
 
@@ -384,6 +382,4 @@
       !
       IF( lk_iomput ) THEN
-         CALL wrk_dealloc( jpi, jpj,     17, zw2d )
-         CALL wrk_dealloc( jpi, jpj, jpk, 3, zw3d )
       ENDIF
       !
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zexp.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zexp.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zexp.F90	(revision 7910)
@@ -64,5 +64,5 @@
       INTEGER  ::   ji, jj, jk, jl, ikt
       REAL(wp) ::   zgeolpoc, zfact, zwork, ze3t, zsedpocd, zmaskt
-      REAL(wp), POINTER, DIMENSION(:,:)   ::  zsedpoca
+      REAL(wp), DIMENSION(jpi,jpj)   ::  zsedpoca
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
@@ -72,5 +72,4 @@
       IF( kt == nittrc000 )   CALL p2z_exp_init
 
-      CALL wrk_alloc( jpi, jpj, zsedpoca ) 
       zsedpoca(:,:) = 0.
 
@@ -147,5 +146,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj, zsedpoca)   ! temporary save of trends
 
       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
@@ -166,6 +164,6 @@
       INTEGER  ::   ji, jj, jk
       REAL(wp) ::   zmaskt, zfluo, zfluu
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zrro
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zdm0
+      REAL(wp), DIMENSION(jpi,jpj) :: zrro
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zdm0
       !!---------------------------------------------------------------------
 
@@ -178,6 +176,4 @@
       !
       ! Allocate temporary workspace
-      CALL wrk_alloc( jpi, jpj,      zrro )
-      CALL wrk_alloc( jpi, jpj, jpk, zdm0 )
 
 
@@ -246,6 +242,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj,      zrro )
-      CALL wrk_dealloc( jpi, jpj, jpk, zdm0 )
       !
    END SUBROUTINE p2z_exp_init
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90	(revision 7910)
@@ -65,6 +65,6 @@
       REAL(wp) ::   zkr, zkg            ! total absorption coefficient in red and green
       REAL(wp) ::   zcoef               ! temporary scalar
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zpar100, zpar0m
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zparr, zparg
+      REAL(wp), DIMENSION(jpi,jpj) :: zpar100, zpar0m
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zparr, zparg
       !!---------------------------------------------------------------------
       !
@@ -72,6 +72,4 @@
       !
       ! Allocate temporary workspace
-      CALL wrk_alloc( jpi, jpj,      zpar100, zpar0m )
-      CALL wrk_alloc( jpi, jpj, jpk, zparr, zparg    )
 
       IF( kt == nittrc000 ) THEN
@@ -140,6 +138,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj,      zpar100, zpar0m )
-      CALL wrk_dealloc( jpi, jpj, jpk, zparr, zparg    )
       !
       IF( nn_timing == 1 )  CALL timing_stop('p2z_opt')
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsed.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsed.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsed.F90	(revision 7910)
@@ -61,6 +61,6 @@
       INTEGER  ::   ji, jj, jk, jl, ierr
       CHARACTER (len=25) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zw2d
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zwork, ztra
+      REAL(wp), DIMENSION(jpi,jpj) :: zw2d
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zwork, ztra
       !!---------------------------------------------------------------------
       !
@@ -74,5 +74,4 @@
 
       ! Allocate temporary workspace
-      CALL wrk_alloc( jpi, jpj, jpk, zwork, ztra )
 
       ! sedimentation of detritus  : upstream scheme
@@ -100,5 +99,4 @@
       IF( lk_iomput )  THEN
          IF( iom_use( "TDETSED" ) ) THEN
-            CALL wrk_alloc( jpi, jpj, zw2d )
             zw2d(:,:) =  ztra(:,:,1) * e3t_n(:,:,1) * 86400._wp
             DO jk = 2, jpkm1
@@ -106,9 +104,7 @@
             END DO
             CALL iom_put( "TDETSED", zw2d )
-            CALL wrk_dealloc( jpi, jpj, zw2d )
          ENDIF
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, zwork, ztra )
       !
 
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zche.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zche.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zche.F90	(revision 7910)
@@ -562,10 +562,8 @@
    LOGICAL   ::  l_exitnow
    REAL(wp), PARAMETER :: pz_exp_threshold = 1.0
-   REAL(wp), POINTER, DIMENSION(:,:,:) :: zalknw_inf, zalknw_sup, rmask, zh_min, zh_max, zeqn_absmin
+   REAL(wp), DIMENSION(jpi,jpj,jpk) :: zalknw_inf, zalknw_sup, rmask, zh_min, zh_max, zeqn_absmin
 
    IF( nn_timing == 1 )  CALL timing_start('solve_at_general')
       !  Allocate temporary workspace
-   CALL wrk_alloc( jpi, jpj, jpk, zalknw_inf, zalknw_sup, rmask )
-   CALL wrk_alloc( jpi, jpj, jpk, zh_min, zh_max, zeqn_absmin )
 
    CALL anw_infsup( zalknw_inf, zalknw_sup )
@@ -797,6 +795,4 @@
    END DO
    !
-   CALL wrk_dealloc( jpi, jpj, jpk, zalknw_inf, zalknw_sup, rmask )
-   CALL wrk_dealloc( jpi, jpj, jpk, zh_min, zh_max, zeqn_absmin )
 
 
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zfechem.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zfechem.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zfechem.F90	(revision 7910)
@@ -74,7 +74,7 @@
       REAL(wp) :: dissol, zligco
       CHARACTER (len=25) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zTL1, zFe3, ztotlig, precip
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zFeL1, zFeL2, zTL2, zFe2, zFeP
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zstrn, zstrn2
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zTL1, zFe3, ztotlig, precip
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zFeL1, zFeL2, zTL2, zFe2, zFeP
+      REAL(wp), DIMENSION(jpi,jpj) :: zstrn, zstrn2
       !!---------------------------------------------------------------------
       !
@@ -82,11 +82,8 @@
       !
       ! Allocate temporary workspace
-      CALL wrk_alloc( jpi, jpj, jpk, zFe3, zFeL1, zTL1, ztotlig, precip )
       zFe3 (:,:,:) = 0.
       zFeL1(:,:,:) = 0.
       zTL1 (:,:,:) = 0.
       IF( ln_fechem ) THEN
-         CALL wrk_alloc( jpi, jpj,      zstrn, zstrn2 )
-         CALL wrk_alloc( jpi, jpj, jpk, zFe2, zFeL2, zTL2, zFeP )
          zFe2 (:,:,:) = 0.
          zFeL2(:,:,:) = 0.
@@ -360,8 +357,5 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, zFe3, zFeL1, zTL1, ztotlig, precip )
       IF( ln_fechem )  THEN
-         CALL wrk_dealloc( jpi, jpj,      zstrn, zstrn2 )
-         CALL wrk_dealloc( jpi, jpj, jpk, zFe2, zFeL2, zTL2, zFeP )
       ENDIF
       !
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zflx.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zflx.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zflx.F90	(revision 7910)
@@ -80,10 +80,9 @@
       REAL(wp) ::   zyr_dec, zdco2dt
       CHARACTER (len=25) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:) :: zkgco2, zkgo2, zh2co3, zoflx, zw2d, zpco2atm  
+      REAL(wp), DIMENSION(jpi,jpj) :: zkgco2, zkgo2, zh2co3, zoflx, zw2d, zpco2atm  
       !!---------------------------------------------------------------------
       !
       IF( nn_timing == 1 )  CALL timing_start('p4z_flx')
       !
-      CALL wrk_alloc( jpi, jpj, zkgco2, zkgo2, zh2co3, zoflx, zpco2atm )
       !
 
@@ -187,5 +186,4 @@
 
       IF( lk_iomput .AND. knt == nrdttrc ) THEN
-         CALL wrk_alloc( jpi, jpj, zw2d )  
          IF( iom_use( "Cflx"  ) )  THEN
             zw2d(:,:) = oce_co2(:,:) / e1e2t(:,:) * rfact2r
@@ -211,8 +209,6 @@
          CALL iom_put( "tcflxcum" , t_oce_co2_flx_cum )      ! molC
          !
-         CALL wrk_dealloc( jpi, jpj, zw2d )
-      ENDIF
-      !
-      CALL wrk_dealloc( jpi, jpj, zkgco2, zkgo2, zh2co3, zoflx, zpco2atm )
+      ENDIF
+      !
       !
       IF( nn_timing == 1 )  CALL timing_stop('p4z_flx')
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zlys.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zlys.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zlys.F90	(revision 7910)
@@ -62,10 +62,9 @@
       REAL(wp) ::   zomegaca, zexcess, zexcess0
       CHARACTER (len=25) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zco3, zcaldiss, zhinit, zhi, zco3sat
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zco3, zcaldiss, zhinit, zhi, zco3sat
       !!---------------------------------------------------------------------
       !
       IF( nn_timing == 1 )  CALL timing_start('p4z_lys')
       !
-      CALL wrk_alloc( jpi, jpj, jpk, zco3, zcaldiss, zhinit, zhi, zco3sat )
       !
       zco3    (:,:,:) = 0.
@@ -139,5 +138,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, zco3, zcaldiss, zhinit, zhi, zco3sat )
       !
       IF( nn_timing == 1 )  CALL timing_stop('p4z_lys')
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zmeso.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zmeso.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zmeso.F90	(revision 7910)
@@ -72,5 +72,5 @@
       REAL(wp) :: zgrazfffp, zgrazfffg, zgrazffep, zgrazffeg
       CHARACTER (len=25) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zgrazing, zw3d
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zgrazing, zw3d
 
       !!---------------------------------------------------------------------
@@ -78,5 +78,4 @@
       IF( nn_timing == 1 )  CALL timing_start('p4z_meso')
       !
-      CALL wrk_alloc( jpi, jpj, jpk, zgrazing )
       zgrazing(:,:,:) = 0._wp
 
@@ -218,5 +217,4 @@
       !
       IF( lk_iomput .AND. knt == nrdttrc ) THEN
-         CALL wrk_alloc( jpi, jpj, jpk, zw3d )
          IF( iom_use( "GRAZ2" ) ) THEN
             zw3d(:,:,:) = zgrazing(:,:,:) * 1.e+3 * rfact2r * tmask(:,:,:)  !   Total grazing of phyto by zooplankton
@@ -227,5 +225,4 @@
             CALL iom_put( "PCAL", zw3d )  
          ENDIF
-         CALL wrk_dealloc( jpi, jpj, jpk, zw3d )
       ENDIF
       !
@@ -236,5 +233,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, zgrazing )
       !
       IF( nn_timing == 1 )  CALL timing_stop('p4z_meso')
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zmicro.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zmicro.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zmicro.F90	(revision 7910)
@@ -71,5 +71,5 @@
       REAL(wp) :: zgrazp, zgrazm, zgrazsd
       REAL(wp) :: zgrazmf, zgrazsf, zgrazpf
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zgrazing, zw3d
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zgrazing, zw3d
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
@@ -77,5 +77,4 @@
       IF( nn_timing == 1 )  CALL timing_start('p4z_micro')
       !
-      CALL wrk_alloc( jpi, jpj, jpk, zgrazing )
       !
       DO jk = 1, jpkm1
@@ -179,10 +178,8 @@
       IF( lk_iomput ) THEN
          IF( knt == nrdttrc ) THEN
-           CALL wrk_alloc( jpi, jpj, jpk, zw3d )
            IF( iom_use( "GRAZ1" ) ) THEN
               zw3d(:,:,:) = zgrazing(:,:,:) * 1.e+3 * rfact2r * tmask(:,:,:)  !  Total grazing of phyto by zooplankton
               CALL iom_put( "GRAZ1", zw3d )
            ENDIF
-           CALL wrk_dealloc( jpi, jpj, jpk, zw3d )
          ENDIF
       ENDIF
@@ -194,5 +191,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, zgrazing )
       !
       IF( nn_timing == 1 )  CALL timing_stop('p4z_micro')
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zopt.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zopt.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zopt.F90	(revision 7910)
@@ -66,8 +66,8 @@
       REAL(wp) ::   zchl
       REAL(wp) ::   zc0 , zc1 , zc2, zc3, z1_dep
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zdepmoy, zetmp1, zetmp2, zetmp3, zetmp4
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zetmp5
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zqsr100, zqsr_corr
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zpar, ze0, ze1, ze2, ze3, zchl3d
+      REAL(wp), DIMENSION(jpi,jpj) :: zdepmoy, zetmp1, zetmp2, zetmp3, zetmp4
+      REAL(wp), DIMENSION(jpi,jpj) :: zetmp5
+      REAL(wp), DIMENSION(jpi,jpj) :: zqsr100, zqsr_corr
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zpar, ze0, ze1, ze2, ze3, zchl3d
       !!---------------------------------------------------------------------
       !
@@ -75,8 +75,4 @@
       !
       ! Allocate temporary workspace
-                   CALL wrk_alloc( jpi, jpj,      zdepmoy, zetmp1, zetmp2, zetmp3, zetmp4 )
-                   CALL wrk_alloc( jpi, jpj,      zqsr100, zqsr_corr )
-      IF( ln_p5z ) CALL wrk_alloc( jpi, jpj,      zetmp5 )
-                   CALL wrk_alloc( jpi, jpj, jpk, zpar   , ze0, ze1, ze2, ze3, zchl3d )
 
       IF( knt == 1 .AND. ln_varpar ) CALL p4z_opt_sbc( kt )
@@ -245,8 +241,4 @@
       ENDIF
       !
-                   CALL wrk_dealloc( jpi, jpj,      zdepmoy, zetmp1, zetmp2, zetmp3, zetmp4 )
-                   CALL wrk_dealloc( jpi, jpj,      zqsr100, zqsr_corr )
-      IF( ln_p5z ) CALL wrk_dealloc( jpi, jpj,      zetmp5 )
-                   CALL wrk_dealloc( jpi, jpj, jpk, zpar   ,  ze0, ze1, ze2, ze3, zchl3d )
       !
       IF( nn_timing == 1 )  CALL timing_stop('p4z_opt')
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zpoc.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zpoc.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zpoc.F90	(revision 7910)
@@ -64,6 +64,6 @@
       REAL(wp) ::   zrfact2
       CHARACTER (len=25) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:  )   :: totprod, totthick, totcons 
-      REAL(wp), POINTER, DIMENSION(:,:,:)   :: zremipoc, zremigoc, zorem3, ztremint
+      REAL(wp), DIMENSION(jpi,jpj)   :: totprod, totthick, totcons 
+      REAL(wp), DIMENSION(jpi,jpj,jpk)   :: zremipoc, zremigoc, zorem3, ztremint
       REAL(wp), POINTER, DIMENSION(:,:,:,:) :: alphag
       !!---------------------------------------------------------------------
@@ -72,6 +72,4 @@
       !
       ! Allocate temporary workspace
-      CALL wrk_alloc( jpi, jpj,      totprod,  totthick, totcons )
-      CALL wrk_alloc( jpi, jpj, jpk, zremipoc, zremigoc, zorem3, ztremint )
       ALLOCATE( alphag(jpi,jpj,jpk,jcpoc) )
 
@@ -466,6 +464,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj,      totprod,  totthick, totcons )
-      CALL wrk_dealloc( jpi, jpj, jpk, zremipoc, zremigoc, zorem3, ztremint )
       DEALLOCATE( alphag )
       !
Index: /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zprod.F90
===================================================================
--- /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zprod.F90	(revision 7909)
+++ /branches/2017/dev_r7881_no_wrk_alloc/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zprod.F90	(revision 7910)
@@ -77,10 +77,10 @@
       REAL(wp) ::   zfact
       CHARACTER (len=25) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zstrn, zw2d, zmixnano, zmixdiat
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zpislopeadn, zpislopeadd, zysopt, zw3d   
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zprdia, zprbio, zprdch, zprnch   
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zprorcan, zprorcad, zprofed, zprofen
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zpronewn, zpronewd
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zmxl_fac, zmxl_chl
+      REAL(wp), DIMENSION(jpi,jpj) :: zstrn, zw2d, zmixnano, zmixdiat
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zpislopeadn, zpislopeadd, zysopt, zw3d   
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zprdia, zprbio, zprdch, zprnch   
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zprorcan, zprorcad, zprofed, zprofen
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zpronewn, zpronewd
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zmxl_fac, zmxl_chl
       !!---------------------------------------------------------------------
       !
@@ -88,8 +88,4 @@
       !
       !  Allocate temporary workspace
-      CALL wrk_alloc( jpi, jpj,      zmixnano, zmixdiat, zstrn )
-      CALL wrk_alloc( jpi, jpj, jpk, zpislopeadn, zpislopeadd, zprdia, zprbio, zprdch, zprnch, zysopt ) 
-      CALL wrk_alloc( jpi, jpj, jpk, zmxl_fac, zmxl_chl )
-      CALL wrk_alloc( jpi, jpj, jpk, zprorcan, zprorcad, zprofed, zprofen, zpronewn, zpronewd )
       !
       zprorcan(:,:,:) = 0._wp ; zprorcad(:,:,:) = 0._wp ; zprofed (:,:,:) = 0._wp
@@ -368,6 +364,4 @@
     IF( lk_iomput ) THEN
        IF( knt == nrdttrc ) THEN
-          CALL wrk_alloc( jpi, jpj,      zw2d )
-          CALL wrk_alloc( jpi, jpj, jpk, zw3d )
           zfact = 1.e+3 * rfact2r  !  conversion from mol/l/kt to  mol/m3/s
           !
@@ -470,6 +464,4 @@
           IF( iom_use( "tintpp" ) )  CALL iom_put( "tintpp" , tpp * zfact )  !  global total integrated primary production molC/s
           !
-          CALL wrk_dealloc( jpi, jpj,      zw2d )
-          CALL wrk_dealloc( jpi, jpj, jpk, zw3d )
        ENDIF
      ENDIF
@@ -481,8 +473,4 @@
      ENDIF
      !
-     CALL wrk_dealloc( jpi, jpj,  zmixnano, zmixdiat,    zstrn )
-     CALL wrk_dealloc( jpi, jpj, jpk, zpislopeadn, zpislopeadd, zprdia, zprbio, zprdch, zprnch, zysopt ) 
-     CALL wrk_dealloc( jpi, jpj, jpk, zmxl_fac, zmxl_chl )
-     CALL wrk_dealloc( jpi, jpj, jpk, zprorcan, zprorcad, zprofed, zprofen, zpronewn, zpronewd )
      !
      IF( nn_timing == 1 )  CALL timing_stop('p4z_prod')
